#!/usr/local/ActivePerl-5.6/bin/perl
#####/usr/bin/perl

#################################################################
# this is the perl server for the big brother flexbot 
# monitoring system
# writen by nick trienens, haha....  have fun

#load modules
#use IO::Socket::INET;
use IO::Select;
use IO::Socket qw(AF_INET INADDR_ANY inet_ntoa);
use Image::Magick;
##################
#varibles for the map
#$map = "";
$height = "50";
$Mcount = 0;

###################################
#varables used to track users######
$updates=1000;
$new_user=1;
$ip = $INADDR_ANY;
$last_full_msg = "<msg></msg>\n";
#don't change this port, unless you also change the flash code
$client_port = '4445';
#don't change this port, unless you also change 
#Big Brother FlexMonitor code to match
$flexIn_port = 5442;
###################################

#########################################################
###declare servers                       ################
$main = new IO::Socket::INET (LocalHost => $ip,
                              LocalPort => $client_port,
                              Listen    => 5,
                              Proto     => 'tcp',
                              Reuse     => 1 ) || die $!;

$flexServ = new IO::Socket::INET (LocalHost => $ip,
                              LocalPort => $flexIn_port,
                              Listen    => 1,
                              Proto     => 'tcp',
                              Reuse     => 1 ) || die $!;
#########################################################

###################################
######set the terminator to null ##
#unfortunatly flash requires chr(0) 
#as the terminating character #####
$old_sep = $/;
$old_sep_two = $\;
$zero = chr(0);
$/ = $zero;
$\ = $zero;
$| = 1;
$map_chg =1;
###################################

#############################
# Initialise IO::Select #####
$handles = new IO::Select();
$handles->add($main);
$handles->add($flexServ);
#############################

print "\nListening for clients on: all ips on port: $client_port"; 
print "\nListening for a position feed on: all ips: $flexIn_port\n";

LISTEN: while (1) {
  ($pending) = IO::Select->select($handles, undef, undef, 60);
  foreach $sock (@$pending) {
    if ($sock == $main){
      $num++;
      my $newsock = $sock->accept();
      print "Got new connection: $num\n"; 
      $newsock->autoflush();
      $number{$newsock} = $num;
      $handles->add($newsock);
      $new_user =1;
    }elsif($sock == $flexServ){
      print "new flexin client accepted\n";
      $msg = "<msg></msg>\n";
      $flexIn= $sock->accept();
      $flexIn->autoflush();
      $handles->add($flexIn);
    }else{
      if($sock == $flexIn){
	#read form FlexIn socket
	$/ = $old_sep;
	$buf = <$sock>;
	$/ = $zero;
	$Mcount++;
	#print "\t\t\t\t U:$Mcount\n";
      }else{
	#read from a client
	$buf = <$sock>;
      }
      if ($buf){
	if($sock != $flexIn){
	  #write to clients
	  $/ = $old_sep;
	  $\ = $old_sep_two;
	  # write tha last complete message to the new client
	  if($new_user){
	    $new_user = 0;
	    print $sock "$last_full_msg\n$zero";
	    #print $sock "$xml_range\n$zero";
	    #print "$xml_range\n$zero";
	  }	  
	  print $sock "$msg\n$zero";
	  print $sock "$xml_range\n$zero";
	  $\ = $zero;
	  $/ = $zero;
	}else{
	  #save the message to flash equal to the message from flexbot
	  if($buf =~ /game_type/){
	   # print "got a full message\n";
	    $last_full_msg = $buf;
	    if( $buf =~ /map="(.*)" game_type/){
	      if($map != $1){
		$map_chg =1;
	      }
	      $map = $1;
	      #print "$map\n";
	      #open(OUT, "> the2.xml");
	      #print OUT "$buf";
	      #close(OUT);
	    }
	  }
	  if($map_chg){
	    if($map){
       	      $map_chg = 0;
	      load_map();
	      print $sock "$xml_range\n$zero";
	    }
	  }
	  $msg = $buf;
	  #open(OUT, "> the.txt");
	  #print OUT "$msg";
	  #close(OUT);
	}
      }else{
	print "Socket $number{$sock} is gone.\n"; 
	#$number{$sock} = -1;
	$handles->remove($sock);
	$msg = "<msg></msg>\n";
	close($sock);
      }
    }
  }
}



sub load_map(){
  $/ = $old_sep;
  $\ = $old_sep_two;
  print "refreshing the map: $map....\n";
  if($map =~ /(.*).bsp/){
    $pict = $1;
  }else{
    $pict = $map;
  }
  $start = $height - 300;
  $end = $height + 300;
  
  system("BSP_slicer -b$start -e$end -t100 -c $map.bsp");
  
  $model=Image::Magick->new();
  $x=$model->ReadImage("$pict.bmp");
  $model->Label('Magick');
  $model->Write("$pict.jpg");
  if(-e "c:\\botTools\\"){
    #print "hello\n\n";
  }else{
    system("mkdir c:\\botTools");
  }
  system("move $pict.jpg c:\\botTools\\$pict.jpg");
  
  open(FILE, "range.txt");
  $line = <FILE>;
  chomp($line);
  if($line =~ /^(.*),(.*),(.*)/){
    $max_x=$1;
    $min_x=$2;
    $scale=$3;
  }
  $line = <FILE>;
  # chomp($line);
     if($line =~ /(.*),(.*),(.*)/){
       $max_y=$1;
       $min_y=$2;
       $scale=$3;
     }
  #($max_y, $min_y, $scale) = split(',',$line);
  
  #system("del range.txt");
  $xml_range = "<msg><xrange scale=\"$scale\" low=\"$min_x\" high=\"$max_x\" /><yrange scale=\"$scale\" low=\"$min_y\" high=\"$max_y\" /></msg>";
  #print $xml_range;
  close(FILE);
}
