################################
# WIRED BOTS
#
# thought();
#
#  desc: This sub grabs a thought from the magicalcheese database
#	 It goes to MC, grabs the total number, randomizes that number.
#	 And grabs the thought with the randomized number.
#  recv: nothing
# sends: $thought
################################
#
# Note: uses get which is part of LWP::Simple, 
# which should be included in bot.pl

sub thought {
#seed the random number generator

#grab the total number of thoughts from the server
$cnt = get "http://magicalcheese.com/tip/data/count.txt";
#randomize a number between 0 and $cnt
$rnd = int(rand($cnt));
#grab that thought via the random number
$thought = get "http://magicalcheese.com/tip/data/$rnd.txt";

#send it back!
return $thought;
}

1;
